﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'B4XMainPage

#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private ion As Object
	Dim PadDir As String
	Dim PadFileName As String
	Dim edtPad As EditText
	Dim btnSaveAs,btnOpen, btnExt As Button
	Dim lblFileName As Label
End Sub

Public Sub Initialize
		
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("Layout")
	btnSaveAs.Visible=True
	btnOpen.Visible=True
	btnExt.Visible=True
	edtPad.Visible=True
	edtPad.Color=Colors.ARGB(220,220,220,220)
End Sub

Private Sub btnSaveAs_Click
	File.WriteString(File.DirInternal, "Type a Filename.txt", edtPad.text)
	Wait For (SaveFile(File.OpenInput(File.DirInternal, "Type a Filename.txt"), "application/octet-stream", "Type a Filename.txt")) Complete (Success As Boolean)
	Log("File saved successfully? " & Success)
End Sub

Sub SaveFile (Source As InputStream, MimeType As String, Title As String) As ResumableSub
	Dim intent As Intent
	intent.Initialize("android.intent.action.CREATE_DOCUMENT", "")
	intent.AddCategory("android.intent.category.OPENABLE")
	intent.PutExtra("android.intent.extra.TITLE", Title)
	intent.SetType(MimeType)
	StartActivityForResult(intent)
	Wait For ion_Event (MethodName As String, Args() As Object)
	If -1 = Args(0) Then 'resultCode = RESULT_OK
		Dim result As Intent = Args(1)
		Dim jo1 As JavaObject = result
		Dim ctxt As JavaObject
		Dim out As OutputStream = ctxt.InitializeContext.RunMethodJO("getContentResolver", Null).RunMethod("openOutputStream", Array(jo1.RunMethod("getData", Null)))
		File.Copy2(Source, out)
		out.Close
		Return True
	End If
	Return False
End Sub

Sub StartActivityForResult(i As Intent)
	Dim jo As JavaObject = GetBA
	ion = jo.CreateEvent("anywheresoftware.b4a.IOnActivityResult", "ion", Null)
	jo.RunMethod("startActivityForResult", Array(ion, i))
End Sub

Sub GetBA As Object
	Dim jo As JavaObject = Me
	Return jo.RunMethod("getBA", Null)
End Sub

Private Sub btnOpen_Click
	Dim FP As String
	Dim ret As String
	If File.IsDirectory(File.DirRootExternal,"Textos") Then
		FP = File.Combine(File.DirRootExternal,"Textos")
	Else
		FP = File.DirRootExternal
	End If

	Dim fd As FileDialog
	fd.FastScroll = True
	fd.FilePath = FP  '  also sets ChosenName to an emtpy string
	fd.FileFilter = ".txt" ' for example or ".jpg,.png" for multiple file types
	ret = fd.Show("Abrir Texto", "Abrir", "", "", Null)
	ToastMessageShow(ret & " : Path : " & fd.FilePath & CRLF & "File : " & fd.ChosenName, False)
	edtPad.Text = File.ReadString(fd.FilePath,fd.ChosenName)
End Sub

Private Sub btnExt_Click
	ExitApplication
	If PadFileName="" Then
	btnSaveAs.Visible=True
	edtPad.Visible=True
	edtPad.Text = ""
	Else
	btnSaveAs.Visible=False
	edtPad.Visible=True
	edtPad.Text = File.ReadString(PadDir, PadFileName)
		lblFileName.Text = PadFileName
	End If
End Sub



